JUCE: SamplerVoice Class Reference

JUCE

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | List of all members
SamplerVoice Class Reference
juce_audio_formats » sampler

A subclass of SynthesiserVoice that can play a SamplerSound. More...

`#include <juce_Sampler.h>`

Inheritance diagram for SamplerVoice:

## Public Member Functions
| SamplerVoice ()
| Creates a SamplerVoice.
| ~SamplerVoice () override
| Destructor.
bool | canPlaySound (SynthesiserSound *) override
| Must return true if this voice object is capable of playing the given sound.
void | startNote (int midiNoteNumber, float velocity, SynthesiserSound *, int pitchWheel) override
| Called to start a new note.
void | stopNote (float velocity, bool allowTailOff) override
| Called to stop a note.
void | pitchWheelMoved (int newValue) override
| Called to let the voice know that the pitch wheel has been moved.
void | controllerMoved (int controllerNumber, int newValue) override
| Called to let the voice know that a midi controller has been moved.
void | renderNextBlock (AudioBuffer< float > &, int startSample, int numSamples) override
| Renders the next block of data for this voice.
virtual void | renderNextBlock (AudioBuffer< float > &outputBuffer, int startSample, int numSamples)=0
| Renders the next block of data for this voice.
virtual void | renderNextBlock (AudioBuffer< double > &outputBuffer, int startSample, int numSamples)
| A double-precision version of renderNextBlock()
Public Member Functions inherited from SynthesiserVoice
| SynthesiserVoice ()
| Creates a voice.
virtual | ~SynthesiserVoice ()
| Destructor.
int | getCurrentlyPlayingNote () const noexcept
| Returns the midi note that this voice is currently playing.
SynthesiserSound::Ptr | getCurrentlyPlayingSound () const noexcept
| Returns the sound that this voice is currently playing.
virtual bool | canPlaySound (SynthesiserSound *)=0
| Must return true if this voice object is capable of playing the given sound.
virtual void | startNote (int midiNoteNumber, float velocity, SynthesiserSound *sound, int currentPitchWheelPosition)=0
| Called to start a new note.
virtual void | stopNote (float velocity, bool allowTailOff)=0
| Called to stop a note.
virtual bool | isVoiceActive () const
| Returns true if this voice is currently busy playing a sound.
virtual void | pitchWheelMoved (int newPitchWheelValue)=0
| Called to let the voice know that the pitch wheel has been moved.
virtual void | controllerMoved (int controllerNumber, int newControllerValue)=0
| Called to let the voice know that a midi controller has been moved.
virtual void | aftertouchChanged (int newAftertouchValue)
| Called to let the voice know that the aftertouch has changed.
virtual void | channelPressureChanged (int newChannelPressureValue)
| Called to let the voice know that the channel pressure has changed.
virtual void | renderNextBlock (AudioBuffer< float > &outputBuffer, int startSample, int numSamples)=0
| Renders the next block of data for this voice.
virtual void | renderNextBlock (AudioBuffer< double > &outputBuffer, int startSample, int numSamples)
| A double-precision version of renderNextBlock()
virtual void | setCurrentPlaybackSampleRate (double newRate)
| Changes the voice's reference sample rate.
virtual bool | isPlayingChannel (int midiChannel) const
| Returns true if the voice is currently playing a sound which is mapped to the given midi channel.
double | getSampleRate () const noexcept
| Returns the current target sample rate at which rendering is being done.
bool | isKeyDown () const noexcept
| Returns true if the key that triggered this voice is still held down.
void | setKeyDown (bool isNowDown) noexcept
| Allows you to modify the flag indicating that the key that triggered this voice is still held down.
bool | isSustainPedalDown () const noexcept
| Returns true if the sustain pedal is currently active for this voice.
void | setSustainPedalDown (bool isNowDown) noexcept
| Modifies the sustain pedal flag.
bool | isSostenutoPedalDown () const noexcept
| Returns true if the sostenuto pedal is currently active for this voice.
void | setSostenutoPedalDown (bool isNowDown) noexcept
| Modifies the sostenuto pedal flag.
bool | isPlayingButReleased () const noexcept
| Returns true if a voice is sounding in its release phase.
bool | wasStartedBefore (const SynthesiserVoice &other) const noexcept
| Returns true if this voice started playing its current note before the other voice did.

## Additional Inherited Members
Protected Member Functions inherited from SynthesiserVoice
void | clearCurrentNote ()
| Resets the state of this voice after a sound has finished playing.

## Detailed Description

A subclass of SynthesiserVoice that can play a SamplerSound.

To use it, create a Synthesiser, add some SamplerVoice objects to it, then give it some SampledSound objects to play.

See also
  SamplerSound, Synthesiser, SynthesiserVoice

## Constructor & Destructor Documentation

## ◆ SamplerVoice()

SamplerVoice::SamplerVoice | ( |  | ) |

Creates a SamplerVoice.

## ◆ ~SamplerVoice()

SamplerVoice::~SamplerVoice | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ canPlaySound()

bool SamplerVoice::canPlaySound | ( | SynthesiserSound * |  | ) |
| overridevirtual

Must return true if this voice object is capable of playing the given sound.

If there are different classes of sound, and different classes of voice, a voice can choose which ones it wants to take on.

A typical implementation of this method may just return true if there's only one type of voice and sound, or it might check the type of the sound object passed-in and see if it's one that it understands.

Implements SynthesiserVoice.

## ◆ startNote()

void SamplerVoice::startNote | ( | int | midiNoteNumber,
|  | float | velocity,
|  | SynthesiserSound * | sound,
|  | int | currentPitchWheelPosition
| ) |  |
| overridevirtual

Called to start a new note.

This will be called during the rendering callback, so must be fast and thread-safe.

Implements SynthesiserVoice.

## ◆ stopNote()

void SamplerVoice::stopNote | ( | float | velocity,
|  | bool | allowTailOff
| ) |  |
| overridevirtual

Called to stop a note.

This will be called during the rendering callback, so must be fast and thread-safe.

The velocity indicates how quickly the note was released - 0 is slowly, 1 is quickly.

If allowTailOff is false or the voice doesn't want to tail-off, then it must stop all sound immediately, and must call clearCurrentNote() to reset the state of this voice and allow the synth to reassign it another sound.

If allowTailOff is true and the voice decides to do a tail-off, then it's allowed to begin fading out its sound, and it can stop playing until it's finished. As soon as it finishes playing (during the rendering callback), it must make sure that it calls clearCurrentNote().

Implements SynthesiserVoice.

## ◆ pitchWheelMoved()

void SamplerVoice::pitchWheelMoved | ( | int | newPitchWheelValue | ) |
| overridevirtual

Called to let the voice know that the pitch wheel has been moved.

This will be called during the rendering callback, so must be fast and thread-safe.

Implements SynthesiserVoice.

## ◆ controllerMoved()

void SamplerVoice::controllerMoved | ( | int | controllerNumber,
|  | int | newControllerValue
| ) |  |
| overridevirtual

Called to let the voice know that a midi controller has been moved.

This will be called during the rendering callback, so must be fast and thread-safe.

Implements SynthesiserVoice.

## ◆ renderNextBlock() [1/3]

void SamplerVoice::renderNextBlock | ( | AudioBuffer< float > & | outputBuffer,
|  | int | startSample,
|  | int | numSamples
| ) |  |
| overridevirtual

Renders the next block of data for this voice.

The output audio data must be added to the current contents of the buffer provided. Only the region of the buffer between startSample and (startSample + numSamples) should be altered by this method.

If the voice is currently silent, it should just return without doing anything.

If the sound that the voice is playing finishes during the course of this rendered block, it must call clearCurrentNote(), to tell the synthesiser that it has finished.

The size of the blocks that are rendered can change each time it is called, and may involve rendering as little as 1 sample at a time. In between rendering callbacks, the voice's methods will be called to tell it about note and controller events.

Implements SynthesiserVoice.

## ◆ renderNextBlock() [2/3]

virtual void SynthesiserVoice::renderNextBlock | ( | AudioBuffer< float > & | outputBuffer,
|  | int | startSample,
|  | int | numSamples
| ) |  |
| virtual

Renders the next block of data for this voice.

The output audio data must be added to the current contents of the buffer provided. Only the region of the buffer between startSample and (startSample + numSamples) should be altered by this method.

If the voice is currently silent, it should just return without doing anything.

If the sound that the voice is playing finishes during the course of this rendered block, it must call clearCurrentNote(), to tell the synthesiser that it has finished.

The size of the blocks that are rendered can change each time it is called, and may involve rendering as little as 1 sample at a time. In between rendering callbacks, the voice's methods will be called to tell it about note and controller events.

Implements SynthesiserVoice.

## ◆ renderNextBlock() [3/3]

virtual void SynthesiserVoice::renderNextBlock | ( | AudioBuffer< double > & | outputBuffer,
|  | int | startSample,
|  | int | numSamples
| ) |  |
| virtual

A double-precision version of renderNextBlock()

Reimplemented from SynthesiserVoice.

The documentation for this class was generated from the following file:

- juce_Sampler.h